using ADerrors
#PDG
const hc = 197.3269804 #MeV fm
const M_values = [1869.65, 2010.26, 1968.34, 2112.2, 2980.3, 3096.916, 5279.65, 5366.3] #MD, MD*, MDs, MDs*, \eta_c, J/\psi , MB, MBs(MeV)
const M_error = [0.05, 0.05, 0.07, 0.4, 1.2, 0.011, 0.12, 0.6]
#1802.05243 
const b_values = [3.40, 3.46, 3.55, 3.70, 3.85]
const ZM_data = [1.9684, 1.9935, 2.0253, 2.0630, 2.0814]
const ZM_error = [35, 27, 33, 38, 45] .* 1e-4
const ZM_tm_data = [2.6047, 2.6181, 2.6312, 2.6339, 2.6127]
const ZM_tm_error = [42, 33, 42, 48, 55] .* 1e-4
#1808.09236
const ZA_data = [0.75642, 0.76169, 0.76979, 0.78378, 0.79667]
const ZA_err = [72, 93, 43, 47, 47] .*1e-5
const ZV_data = [0.72259, 0.72845, 0.73886, 0.75574, 0.77074]
const ZV_err = [74, 89, 46, 48, 49] .* 1e-5
#2005.01352
const ZS_over_ZP_data = [1.3497, 1.2914, 1.2317, 1.1709, 1.1343]
const ZS_over_ZP_err = [83, 64, 48, 23, 25 ] .* 1e-4
#2101.02694
# const b_values2 = [3.40, 3.46, 3.55, 3.70]
const t0_data = [2.846, 3.634, 5.140, 8.564, 14.064]
const t0_error = [8, 13, 21, 24, 63] .* 1e-3
# from AS analysis 
const t0_ph_value = [0.4118]
const t0_ph_error = ones(1,1) .* 25e-4
#2101.10969
const RM_data = [2.335, 1.869, 1.523, 1.267, 1.149]
const RM_err  = [31, 19, 14, 16, 18] .* 1e-3
#1906.03445 LCP1 for heavy quarks 
const BA_MINUS_BP_data = [-0.324, -0.265, -0.196, -0.119, -0.073]
const BA_MINUS_BP_err  = [17, 14, 14, 14, 12] .*1e-3 
const ZDATA = [0.8981, 0.9468, 1.0015, 1.0612, 1.0971]
const ZERR  = [35, 35, 30, 17, 18 ] .* 1e-4

#1802.05243 taking into account correlations in zm_tm
C = [[0.375369e-6, 0.429197e-6, -0.186896e-5] [0.429197e-6, 0.268393e-4, 0.686776e-4] [-0.186896e-5, 0.686776e-4, 0.212386e-3]]
z = cobs([0.348629, 0.020921, 0.070613], C, "z")
ZP(b) = z[1] + z[2] * (b - 3.79) + z[3] * (b - 3.79)^2
Mrat = uwreal([.9148, 0.0088], "M/mhad")
zm_tm_covar(b) = Mrat / ZP(b)
# same for zm wilson
CC = [[0.164635e-4, 0.215658e-4, -0.754203e-4] [0.215658e-4, 0.121072e-2, 0.308890e-2] [-0.754203e-4, 0.308890e-2, 0.953843e-2]]
zz = cobs([2.270073, 0.121644, -0.464575], CC, "zm")
z_covar(b) = value(Mrat) * (zz[1] + zz[2]*(b-3.79) + zz[3]*(b-3.79)^2)

## taking into account correlations in r_m
#Crm = [[3.699760, -2.198586, -1.476913e-3] [-2.198586, 1.306512, 8.776569e-4] [-1.476913e-3, 8.776569e-4, 5.895710e-7] ]
#c_i = cobs([-7.86078, 5.49175, -0.54078], Crm, "c_i in rm")
#rm(b::Float64) = 1.0 +  0.004630*(6/b)^4 * ((1. +c_i[1]*(6/b)^2 + c_i[2]*(6/b)^4) / (1. + c_i[3]*(6/b)^2))

##
#Cov matrices
const C1 = zeros(5, 5)
const C2 = zeros(5, 5)
const C3 = zeros(5, 5)
const C4 = zeros(8, 8)
const C5 = zeros(5, 5)
const C6 = zeros(5, 5)
const C7 = zeros(5, 5)
const C8 = zeros(5, 5)
const C9 = zeros(5, 5)
const C10 = zeros(5, 5)

for i = 1:8
    C4[i, i] = M_error[i] ^ 2
    if i<=5
        C1[i, i] = ZM_error[i] ^ 2
        C2[i, i] = ZM_tm_error[i] ^ 2
        C5[i, i] = ZA_err[i] ^ 2
        C6[i, i] = ZS_over_ZP_err[i] ^ 2
        C7[i, i] = ZV_err[i] ^ 2       
        C8[i, i] = RM_err[i] ^2 
        C9[i,i]  = BA_MINUS_BP_err[i] ^2
        C10[i,i]  = ZERR[i] ^2
        C3[i, i] = t0_error[i] ^ 2
    end

end
const ZM = cobs(ZM_data, C1, "ZM values")
const ZM_tm = cobs(ZM_tm_data, C2, "ZM_tm values")
const t0_ = cobs(t0_data, C3, "t0")
const t0_ph = cobs(t0_ph_value, t0_ph_error .^ 2, "sqrt(8 t0) (fm)")
const a_ = t0_ph ./ sqrt.(8 .* t0_)
const M = cobs(M_values, C4, "charmed meson masses")
const Za = cobs(ZA_data, C5, "ZA")
const Zv = cobs(ZV_data, C7, "ZV")
const ZS_over_ZP = cobs(ZS_over_ZP_data, C6, "ZS/ZP")
const RM = cobs(RM_data, C8, "rm")
const BA_BP = cobs(BA_MINUS_BP_data, C9, "ba-bp")
const ZZ = cobs(ZDATA, C10, "Z")

zm(beta::Float64)         = ZM[b_values .== beta][1]
zm_tm(beta::Float64)      = ZM_tm[b_values .== beta][1]
t0(beta::Float64)         = t0_[b_values .== beta][1]
a(beta::Float64)          = a_[b_values .== beta][1]
za(beta::Float64)         = Za[b_values .== beta][1]
zv(beta::Float64)         = Zv[b_values .== beta][1]
zs_over_zp(beta::Float64) = ZS_over_ZP[b_values .== beta][1]
rm(beta::Float64)         = RM[b_values .== beta][1]
ba_bp(beta::Float64)      = BA_BP[b_values .== beta][1]
Z(beta::Float64)          = ZZ[b_values .== beta][1]

const ens_db = Dict(
    #"ens_id"=>[L, T, beta, dtr, vrw, trunc_cnfg]
    "H101"     => [32, 96, 3.4, 2, "1.2", [1001,1009]],
    "H102r001" => [32, 96, 3.4, 2, "2.0", [997]],
    "H102r002" => [32, 96, 3.4, 2, "2.0", [1008]],
    "H105"     => [32, 96, 3.4, 2, "2.0", [947,1042]],
    "H105r005" => [32, 96, 3.4, 1, "1.2", [837]],
    "H400"     => [32, 96, 3.46, 1, "1.2", [505,540]],
    "D450"     => [64, 128, 3.46, 1, ["2.0"], [1000]],
    "N202"     => [48, 128, 3.55, 2, "1.2", [899]],
    "N203"     => [48, 128, 3.55, 1, "2.0", [756,787]],
    "N200"     => [48, 128, 3.55, 1, "2.0", [856,856]],
    "D200"     => [64, 128, 3.55, 2, "2.0", [2001]],
    "E250"     => [96, 192, 3.55, 1, ["2.0"], [1009]],
    "N300"     => [48, 128, 3.70, 1, "1.2", [1521]],
    "N302"     => [48, 128, 3.70, 1, "1.2", [2201]],
    "J303"     => [64, 192, 3.70, 2, "2.0", [1073]],
    "E300"     => [96, 192, 3.70, 1, ["1.4"], [1139]],
    "J500"     => [64, 192, 3.85, 2, ["1.2", "1.4", "2.0"], [789,655,431]],
    "J501"     => [64, 192, 3.85, 1, ["1.2", "1.4", "2.0"], [1635,1142,1150]]
)


const db = Dict(
    "J501" => ["ts001_chunk1", "ts001_chunk3", "ts190_chunk1", "ts190_chunk2"],
    "J500" => ["ts001_chunk1", "ts001_chunk2", "ts190_chunk1", "ts190_chunk2"],
    "E250" => ["ts001", "ts097"],
    "E300" => ["ts001_chunk2", "ts001_chunk3", "ts190_chunk1"],#, "ts001_chunk1"],
    "D450" => ["ts001", "ts065_1", "ts065_2"]
)

const db_c = Dict(
    "J501" => ["ts001", "ts190"],
    "J500" => ["ts001_chunk1", "ts190_chunk2"],
    "E250" => ["ts001"],
    "E300" => ["ts001_chunk2"],#, "ts001_chunk1"]
    "D450" => ["ts001_1", "ts001_2"]
)

const sym_bool = Dict(
    "J501" => true,
    "J500" => true,
    "E250" => false,
    "E300" => false,
    "D450" => false
)

const flag_s = Dict(
    "J303r003" => [324,325,326],
    "H105r001" => [100,105,106],
    "H105r002" => [1],
    "H105r005" => [254, 255, 256, 257, 259, 260, 261, 264, 265, 266, 269, 280, 282, 283, 284, 285, 286, 287, 288, 289, 291, 299, 301, 313, 314, 315, 316, 331, 332, 333, 334, 335, 336, 337, 338, 339, 340, 341, 342]
)

const ensemble_inv = Dict(
    "H101"     => 1,
    "H102r001" => 2,
    "H102r002" => 3,
    "H105"     => 4,
    "H105r005" => 5,
    "H400"     => 6,
    "D450"     => 7,
    "N202"     => 8,
    "N203"     => 9,
    "N200"     => 10,
    "D200"     => 11,
    "E250"     => 12,
    "N300"     => 13,
    "N302"     => 14,
    "J303"     => 15,
    "E300"     => 16,
    "J500"     => 17,
    "J501"     => 18
)